#ifndef _CONFIG_H
#define _CONFIG_H

#define R_JPAD				0x0001
#define L_JPAD				0x0002
#define D_JPAD				0x0004
#define U_JPAD				0x0008
#define START_BUTTON	0x0010
#define Z_TRIG				0x0020
#define B_BUTTON			0x0040
#define A_BUTTON			0x0080

#define R_CBUTTONS		0x0100
#define L_CBUTTONS		0x0200
#define D_CBUTTONS		0x0400
#define U_CBUTTONS		0x0800
#define L_TRIG				0x1000
#define R_TRIG				0x2000

typedef struct
{
  int diHandle;
  __int32 StickUp, StickDown, StickLeft, StickRight;
  int AxeForStickUpDown;
  int AxeForStickLeftRight;
  __int32 PadUp, PadDown, PadLeft, PadRight;
  __int32 ButtonA, ButtonB;
  __int32 ButtonCUp, ButtonCDown, ButtonCLeft, ButtonCRight;
  __int32 ButtonStart;
  __int32 TriggerLeft, TriggerRight, TriggerZ;
} ControllerDef;

extern ControllerDef Controllers[4];

extern bool g_bUseKaillera;
extern bool g_bKailleraViewLog;
extern int g_iKailleraPlayAs;
extern char g_szKailleraDll[256];

void ReadConfiguration();
void WriteConfiguration();

void PrintConfigurationDialog(HWND hParent);

void SetDefaultController();

#endif //_CONFIG_H
