#include "stdafx.h"
#include "noote_di.h"

#include "controller.h"
#include "config.h"

#include "kaillera.h"

HINSTANCE hKailleraDll = NULL;

int (__stdcall *pDllKailleraGetVersion)(char *version) = NULL;
int (__stdcall *pDllKailleraInit)(void) = NULL;
int (__stdcall *pDllKailleraShutdown)(void) = NULL;
int (__stdcall *pDllKailleraSetInfos)(kailleraInfos *infos) = NULL;
int (__stdcall *pDllKailleraSelectServerDialog)(HWND parent) = NULL;
int (__stdcall *pDllKailleraModifyPlayValues)(void *values, int size) = NULL;
int (__stdcall *pDllKailleraChatSend)(char *text) = NULL;
int (__stdcall *pDllKailleraEndGame)(void) = NULL;

//////////////////////////////////////
// Dynamic Loading of Kaillera 0.84 //
//////////////////////////////////////
bool LoadDllKaillera()
{
	UnloadDllKaillera();
  
	hKailleraDll = LoadLibrary(g_szKailleraDll);
  if (hKailleraDll == NULL)
		return false;

  pDllKailleraGetVersion  = (int (__stdcall*)(char *))GetProcAddress(hKailleraDll, "_kailleraGetVersion@4");
	if(pDllKailleraGetVersion == NULL)
		return false;

  pDllKailleraInit  = (int (__stdcall*)(void))GetProcAddress(hKailleraDll, "_kailleraInit@0");
	if(pDllKailleraInit == NULL)
		return false;

  pDllKailleraShutdown  = (int (__stdcall*)(void))GetProcAddress(hKailleraDll, "_kailleraShutdown@0");
	if(pDllKailleraShutdown == NULL)
		return false;

  pDllKailleraSetInfos  = (int (__stdcall*)(kailleraInfos *))GetProcAddress(hKailleraDll, "_kailleraSetInfos@4");
	if(pDllKailleraSetInfos == NULL)
		return false;

  pDllKailleraSelectServerDialog  = (int (__stdcall*)(HWND))GetProcAddress(hKailleraDll, "_kailleraSelectServerDialog@4");
	if(pDllKailleraSelectServerDialog == NULL)
		return false;

  pDllKailleraModifyPlayValues  = (int (__stdcall*)(void *values, int size))GetProcAddress(hKailleraDll, "_kailleraModifyPlayValues@8");
	if(pDllKailleraModifyPlayValues == NULL)
		return false;

  pDllKailleraChatSend  = (int (__stdcall*)(char *))GetProcAddress(hKailleraDll, "_kailleraChatSend@4");
	if(pDllKailleraChatSend == NULL)
		return false;

  pDllKailleraEndGame  = (int (__stdcall*)(void))GetProcAddress(hKailleraDll, "_kailleraEndGame@0");
	if(pDllKailleraEndGame == NULL)
		return false;

	bKailleraDllLoaded = true;
	return true;
}

bool UnloadDllKaillera()
{
	bKailleraDllLoaded = false;

	pDllKailleraGetVersion = NULL;
	pDllKailleraInit = NULL;
	pDllKailleraShutdown = NULL;
	pDllKailleraSetInfos = NULL;
	pDllKailleraSelectServerDialog = NULL;
	pDllKailleraModifyPlayValues = NULL;
	pDllKailleraChatSend = NULL;
	pDllKailleraEndGame = NULL;

  if (hKailleraDll != NULL)
    FreeLibrary(hKailleraDll);
	hKailleraDll = NULL;

	return true;
}

int kailleraGetVersion(char *version)
{
	if(bKailleraDllLoaded && pDllKailleraGetVersion != NULL)
		return pDllKailleraGetVersion(version);
	strcpy(version, "No Kaillera Dll");
	return 0;
}
int kailleraInit()
{
	if(bKailleraDllLoaded && pDllKailleraInit != NULL)
		return pDllKailleraInit();
	return 0;
}
int kailleraShutdown()
{
	if(bKailleraDllLoaded && pDllKailleraShutdown != NULL)
		return pDllKailleraShutdown();
	return 0;
}
int kailleraSetInfos(kailleraInfos *infos)
{
	if(bKailleraDllLoaded && pDllKailleraSetInfos != NULL)
		return pDllKailleraSetInfos(infos);
	return 0;
}
int kailleraSelectServerDialog(HWND parent)
{
	if(bKailleraDllLoaded && pDllKailleraSelectServerDialog != NULL)
		return pDllKailleraSelectServerDialog(parent);
	return 0;
}
int kailleraModifyPlayValues(void *values, int size)
{
	if(bKailleraDllLoaded && pDllKailleraModifyPlayValues != NULL)
		return pDllKailleraModifyPlayValues(values, size);
	return 0;
}
int kailleraChatSend(char *text)
{
	if(bKailleraDllLoaded && pDllKailleraChatSend != NULL)
		return pDllKailleraChatSend(text);
	return 0;
}
int kailleraEndGame()
{
	if(bKailleraDllLoaded && pDllKailleraEndGame != NULL)
		return pDllKailleraEndGame();
	return 0;
}

