// NooTe_DI.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "NooTe_DI.h"
#include "AboutBox.h"
#include "TestDialog.h"

#include <dinput.h>
#include "controller.h"
#include "Kaillera.h"
#include "config.h"
#include "di.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only CNooTe_DIApp object

CNooTe_DIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNooTe_DIApp

BEGIN_MESSAGE_MAP(CNooTe_DIApp, CWinApp)
	//{{AFX_MSG_MAP(CNooTe_DIApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNooTe_DIApp construction

CNooTe_DIApp::CNooTe_DIApp()
{
  SetDefaultController();
  Void_DI();
}

CNooTe_DIApp::~CNooTe_DIApp()
{
}

BOOL CNooTe_DIApp::InitInstance() 
{
  ReadConfiguration();
	LoadDllKaillera();
	kailleraInit();

	KailleraLog.Create();
	
	return CWinApp::InitInstance();
}

int CNooTe_DIApp::ExitInstance() 
{
  KailleraLog.Destroy();

	Close_DI();
	CloseKaillera();
	kailleraShutdown();
	UnloadDllKaillera();
	
	return CWinApp::ExitInstance();
}

/******************************************************************
  Function: GetDllInfo
  Purpose:  This function allows the emulator to gather information
    about the dll by filling in the PluginInfo structure.
  input:    a pointer to a PLUGIN_INFO stucture that needs to be
    filled by the function. (see def above)
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void GetDllInfo ( PLUGIN_INFO * PluginInfo )
{
  if(PluginInfo)
  {
    CString strVersion;
		strVersion.LoadString(IDS_VERSION);
#ifdef _DEBUG
		strVersion += CString("d");
#endif

    PluginInfo->Version = 0x0100;
    PluginInfo->Type = PLUGIN_TYPE_CONTROLLER;
    strncpy(PluginInfo->Name, strVersion, sizeof(PluginInfo->Name));
    PluginInfo->NormalMemory   = FALSE;
    PluginInfo->MemoryBswaped  = TRUE;
  }
}

/******************************************************************
  Function: CloseDLL
  Purpose:  This function is called when the emulator is closing
    down allowing the dll to de-initialise.
  input:    none
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void CloseDLL (void)
{
  Close_DI();
	CloseKaillera();
}

/******************************************************************
  Function: DllAbout
  Purpose:  This function is optional function that is provided
    to give further information about the DLL.
  input:    a handle to the window that calls this function
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void DllAbout ( HWND hParent )
{
  PrintAboutBox(hParent);
}

/******************************************************************
  Function: DllConfig
  Purpose:  This function is optional function that is provided
    to allow the user to configure the dll
  input:    a handle to the window that calls this function
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void DllConfig ( HWND hParent )
{
	Open_DI(hParent);
  PrintConfigurationDialog(hParent);
	Close_DI();
}

/******************************************************************
  Function: DllTest
  Purpose:  This function is optional function that is provided
    to allow the user to test the dll
  input:    a handle to the window that calls this function
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void DllTest ( HWND hParent )
{
	Open_DI(hParent);
	PrintTestDialog(hParent);
	Close_DI();
}

/******************************************************************
  Function: RomOpen
  Purpose:  This function is called when a rom is open. (from the 
    emulation thread)
  input:    none
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void RomOpen (void)
{
	Open_DI(hWndInput);
  iGetKeysCounter = 0;

	if(g_bUseKaillera)
		LaunchKaillera();
}

/******************************************************************
  Function: RomClosed
  Purpose:  This function is called when a rom is closed.
  input:    none
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void RomClosed (void)
{
	if(g_bUseKaillera)
		CloseKaillera();
	
	Close_DI();
}

/******************************************************************
  Function: WM_KeyDown
  Purpose:  An optional function to pass the WM_KEYDOWN message 
            from the emulator to the plugin.
  input:    wParam and lParam of the WM_KEYDOWN message.
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void WM_KeyDown( WPARAM wParam, LPARAM lParam )
{
}


/******************************************************************
  Function: WM_KeyUp
  Purpose:  An optional function to pass the WM_KEYUP message 
            from the emulator to the plugin.
  input:    wParam and lParam of the WM_KEYDOWN message.
  output:   none
*******************************************************************/ 
extern "C" __declspec(dllexport) void WM_KeyUp( WPARAM wParam, LPARAM lParam )
{
}
